﻿
using System;
using System.Threading;
using Wisej.Web;

namespace Wisej.AddControlsBackgroundTask
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		private bool addingControls = false;

		private void button1_Click(object sender, EventArgs e)
		{
			if (this.addingControls)
			{
				this.addingControls = false;
				this.button1.Text = "Start Adding Controls";
				return;
			}
			else
			{

				this.addingControls = true;
				this.panel1.Controls.Clear();
				this.button1.Text = "Stop Adding Controls";

				Application.StartTask(() =>
				{

					while (this.addingControls)
					{
						Thread.Sleep(1000);
						this.panel1.Controls.Add(new Button() {
							Text = "New Button",
							Dock = DockStyle.Top
						});

						Application.Update(this);
					}

				});
			}
		}

		private bool addingRows = false;

		private void button2_Click(object sender, EventArgs e)
		{
			if (this.addingRows)
			{
				this.addingRows = false;
				this.button2.Text = "Start Adding Rows";
				return;
			}
			else
			{

				this.addingRows = true;
				this.dataGridView1.Rows.Clear();
				this.button2.Text = "Stop Adding Rows";

				Application.StartTask(() =>
				{

					while (this.addingRows)
					{
						Thread.Sleep(1000);

						var newRow = new DataGridViewRow();
						this.dataGridView1.Rows.Add(newRow);
						newRow[0].Value = "New Row";

						Application.Update(this);
					}

				});
			}
		}
	}
}
